<?php
/**
 * CleverReach WooCommerce Integration.
 *
 * @package CleverReach
 */

namespace CleverReach\WooCommerce\Components\Services\BusinessLogic;

use CleverReach\WooCommerce\IntegrationCore\BusinessLogic\Group\GroupService;

/**
 * Class Group_Service
 *
 * @package CleverReach\WooCommerce\Components\Services\BusinessLogic
 */
class Group_Service extends GroupService {

	/**
	 * Retrieves name
	 *
	 * @inheritDoc
	 */
	public function getName() {
		return $this->getConfigurationService()->getIntegrationName() . ' - ' . get_bloginfo( 'name' );
	}

	/**
	 * Retrieves suffix of blacklisted emails.
	 *
	 * @inheritDoc
	 */
	public function getBlacklistedEmailsSuffix() {
		return '-' . $this->getConfigurationService()->getIntegrationName();
	}
}
