<?php
/**
 * CleverReach WooCommerce Integration.
 *
 * @package CleverReach
 */

namespace CleverReach\WooCommerce\Components\Services\BusinessLogic;

use CleverReach\WooCommerce\IntegrationCore\BusinessLogic\Field\Contracts\FieldType;
use CleverReach\WooCommerce\IntegrationCore\BusinessLogic\Field\DTO\Field;
use CleverReach\WooCommerce\IntegrationCore\BusinessLogic\Field\FieldService;

/**
 * Class Receiver_Fields_Service
 *
 * @package CleverReach\WooCommerce\Components\Services\BusinessLogic
 */
class Receiver_Fields_Service extends FieldService {

	/**
	 * Retrieves supported fields
	 *
	 * @return Field[]
	 */
	protected function getSupportedFields() {
		return array_merge(
			parent::getSupportedFields(),
			array(
				new Field( 'shop', FieldType::TEXT ),
				new Field( 'customernumber', FieldType::TEXT ),
				new Field( 'lastorderdate', FieldType::DATE ),
				new Field( 'ordercount', FieldType::NUMBER ),
				new Field( 'totalspent', FieldType::NUMBER ),
			)
		);
	}
}
