<?php
/**
 * CleverReach WooCommerce Integration.
 *
 * @package CleverReach
 */

namespace CleverReach\WooCommerce\ViewModel\Settings;

use CleverReach\WooCommerce\Components\Repositories\Customers\Subscriber_Repository;

/**
 * Class Sync_Settings
 *
 * @package CleverReach\WooCommerce\ViewModel\Settings
 */
class Sync_Settings {

	/**
	 * Subscriber Repository
	 *
	 * @var Subscriber_Repository
	 */
	private $subscriber_repository;

	/**
	 * Sync_Settings constructor.
	 */
	public function __construct() {
		$this->subscriber_repository = new Subscriber_Repository();
	}

	/**
	 * Checks if subscribers exist in system
	 *
	 * @return string
	 */
	public function get_subscribers_exists() {
		return $this->subscriber_repository->count() > 0 ? '1' : '0';
	}
}
