<?php

use CleverReach\WooCommerce\ViewModel\InitialSyncSettings\Initial_Sync_Settings_Config;
use CleverReach\WooCommerce\ViewModel\InitialSyncSettings\Receivers_Data;

$config = Initial_Sync_Settings_Config::get_initial_sync_settings_config();

$receiver_data_model = new Receivers_Data();

?>

<input type="hidden" id="crSaveSettingsBeforeUrl" value="<?php echo $config['saveSettingsUrl'] ?>">
<input type="hidden" id="crCancelSettingsBeforeUrl" value="<?php echo $config['cancelUrl'] ?>">

<input type="hidden" id="crSubscribersExist"
       value="<?php echo $receiver_data_model->get_subscribers_exist() ?>">

<div class="wrap cr-container">
    <h2><?php echo esc_html( __( 'Import Receivers', 'cleverreach-wc' ) ) ?></h2>
    <p>
		<?php echo esc_html( __( 'Select receivers to import. Observe the guidelines of the General Data Protection Regulation.',
		                  'cleverreach-wc' ) ) ?>
    </p>
    <a href=" <?php echo esc_attr( __( 'https://support.cleverreach.de/hc/en-us/articles/360013571280',
	                            'cleverreach-wc' ) ) ?>"
       target="_blank">
		<?php echo esc_html( __( 'Learn more about data protection', 'cleverreach-wc' ) ) ?>
    </a>
    <table class="form-table">
        <tbody>
        <tr valign="top">
            <td class="forminp forminp-text">
                <fieldset class="<?php echo $receiver_data_model->get_subscribers_exist() !== '1' ? 'cr-hidden' : '' ?>">
                    <legend class="screen-reader-text">
                        <span>checkbox</span>
                    </legend>
                    <label for="crSubscribersCheckbox">
                        <input name="crSubscribersCheckbox" type="checkbox" id="crSubscribersCheckbox" checked readonly
                               disabled value="1">
						<?php echo esc_html( __( 'Subscriber', 'cleverreach-wc' ) ) ?>
                        (<?php echo $receiver_data_model->get_subscribers_count() ?>)
                    </label>
                    <p class="description">
						<?php echo esc_html( __( 'Subscribed to your newsletter.', 'cleverreach-wc' ) ) ?>
                    </p>
                </fieldset>
                <fieldset>
                    <legend class="screen-reader-text">
                        <span>checkbox</span>
                    </legend>
                    <label for="crBuyersCheckbox" data-buyers="<?php echo $receiver_data_model->get_buyers_count() ?>">
                        <input name="crBuyersCheckbox" type="checkbox" id="crBuyersCheckbox" value="1">
						<?php echo esc_html( __( 'Buyer', 'cleverreach-wc' ) ) ?>
                        (<?php echo $receiver_data_model->get_buyers_count() ?>)
                    </label>
                    <p class="description">
						<?php echo esc_html( __( 'Bought something from your store.', 'cleverreach-wc' ) ) ?>
                    </p>
                </fieldset>
                <fieldset>
                    <legend class="screen-reader-text">
                        <span>checkbox</span>
                    </legend>
                    <label for="crContactsCheckbox" data-contacts="<?php echo $receiver_data_model->get_contacts_count() ?>">
                        <input name="crContactsCheckbox" type="checkbox" id="crContactsCheckbox" value="1">
						<?php echo esc_html( __( 'Contacts', 'cleverreach-wc' ) ) ?>
                        (<?php echo $receiver_data_model->get_contacts_count() ?>)
                        <p class="description">
							<?php echo esc_html( __( 'Didn\'t subscribe or buy.', 'cleverreach-wc' ) ) ?>
                        </p>
                    </label>
                </fieldset>
            </td>
        </tr>
        </tbody>
    </table>
    <button class="button cr-primary" id="crInitialSyncSettingsImportButton"><?php echo esc_html( __( 'Import receivers',
	                                                                                           'cleverreach-wc' ) ) ?></button>
    <button class="button cr-secondary" id="crInitialSyncSettingsCancelButton"><?php echo esc_html( __( 'Cancel',
	                                                                                             'cleverreach-wc' ) ) ?></button>

</div>
