<?php

namespace CleverReach\WooCommerce\IntegrationCore\BusinessLogic\SecondarySynchronization\Tasks\Composite;

use CleverReach\WooCommerce\IntegrationCore\BusinessLogic\Receiver\Tasks\Composite\ReceiverSyncTask;
use CleverReach\WooCommerce\IntegrationCore\BusinessLogic\SyncSettings\Tasks\UpdateSyncSettingsTask;
use CleverReach\WooCommerce\IntegrationCore\Infrastructure\TaskExecution\CompositeTask;

class SecondarySyncTask extends CompositeTask
{
    /**
     * SecondarySyncTask constructor.
     */
    public function __construct()
    {
        parent::__construct($this->getSubTasks());
    }

    /**
     * @inheritDoc
     */
    protected function createSubTask($taskKey)
    {
        return new $taskKey;
    }

    /**
     * Returns list of subtasks
     *
     * @return array
     */
    protected function getSubTasks()
    {
        return array(
            UpdateSyncSettingsTask::CLASS_NAME => 5,
            ReceiverSyncTask::CLASS_NAME => 95,
        );
    }
}